/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.pvp.EPvPStage
 *  fire.pb.battle.pvp.IPvPStage
 *  fire.pb.battle.pvp.PvPControl
 *  fire.pb.battle.pvp.PvPResult
 *  fire.pb.buff.Module
 *  fire.pb.main.ConfigManager
 *  fire.pb.map.MapConfig
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.map.Transfer
 *  fire.pb.talk.MessageMgr
 *  fire.pb.team.TeamManager
 *  fire.pb.util.StringConstant
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  org.apache.log4j.Logger
 *  xbean.Pod
 *  xbean.PvP5Race
 *  xtable.Properties
 *  xtable.Pvp5races
 */
package fire.pb.battle.pvp5;

import fire.pb.battle.pvp.EPvPStage;
import fire.pb.battle.pvp.IPvPStage;
import fire.pb.battle.pvp.PvPControl;
import fire.pb.battle.pvp.PvPResult;
import fire.pb.battle.pvp5.PvP5CampCountdown;
import fire.pb.battle.pvp5.PvP5CampPolicy;
import fire.pb.battle.pvp5.PvP5Helper;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.battle.pvp5.PvP5RankVisitor;
import fire.pb.battle.pvp5.PvP5RoleProxy;
import fire.pb.battle.pvp5.PvP5RoleStateManager;
import fire.pb.battle.pvp5.PvP5Stage;
import fire.pb.buff.Module;
import fire.pb.main.ConfigManager;
import fire.pb.map.MapConfig;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.map.Transfer;
import fire.pb.talk.MessageMgr;
import fire.pb.team.TeamManager;
import fire.pb.util.StringConstant;
import java.util.List;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import mkdb.Mkdb;
import mkdb.Procedure;
import mkdb.Transaction;
import org.apache.log4j.Logger;
import xbean.Pod;
import xbean.PvP5Race;
import xtable.Properties;
import xtable.Pvp5races;

public class PvP5Control
extends PvPControl {
    private ScheduledFuture<?> futureAward = null;

    public static PvP5Control getInstance() {
        return SingletonHolder.singleton;
    }

    public static Logger getLogger() {
        return logger;
    }

    public final void createScheduleAward(long period, long delay, Runnable command) {
        this.removeScheduleAward();
        period = Math.max(1L, period);
        delay = Math.max(1L, delay);
        this.futureAward = Mkdb.executor().scheduleAtFixedRate(command, delay, period, TimeUnit.SECONDS);
    }

    public final void removeScheduleAward() {
        if (this.futureAward != null) {
            this.futureAward.cancel(true);
            this.futureAward = null;
        }
    }

    public void init(long start, long end, long fightStart, long fightEnd) {
        super.init(start, end, fightStart, fightEnd);
        PvP5CampPolicy.init();
        PvP5CampCountdown.getInstance().init();
        PvP5RoleStateManager.getInstance().init();
        if (logger.isInfoEnabled()) {
            logger.info((Object)"PVP5::[PvP5Control.init] .");
        }
    }

    public void end() {
        super.end();
        if (logger.isInfoEnabled()) {
            logger.info((Object)"PVP5::[PvP5Control.end] .");
        }
    }

    public void close() {
        for (final int grade : PvP5Helper.getAllRaceIds()) {
            new Procedure(){

                protected boolean process() {
                    PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(grade);
                    race.acceptVisit(new PvP5RankVisitor());
                    race.clear();
                    return true;
                }
            }.submit();
        }
    }

    protected void registerStage() {
        this.stageManager.register(EPvPStage.NOTOPEN, (IPvPStage)new PvP5Stage.NotOpen());
        this.stageManager.register(EPvPStage.START, (IPvPStage)new PvP5Stage.Start());
        this.stageManager.register(EPvPStage.PREPARE, (IPvPStage)new PvP5Stage.Prepare());
        this.stageManager.register(EPvPStage.FIGHT, (IPvPStage)new PvP5Stage.Fight());
        this.stageManager.register(EPvPStage.END, (IPvPStage)new PvP5Stage.End());
        this.stageManager.register(EPvPStage.AWARD, (IPvPStage)new PvP5Stage.Award());
    }

    public int getActivityNpcConfigId() {
        return 9;
    }

    public boolean doApplyEnter(long roleId, int gotoType) {
        if (!this.isActivityTime()) {
            MessageMgr.sendMsgNotify((long)roleId, (int)160348, null);
            return false;
        }
        PvP5RoleProxy pvpRoleProxy = PvP5RoleProxy.getPvP5RoleProxy(roleId, true);
        if (pvpRoleProxy == null) {
            return false;
        }
        int grade = pvpRoleProxy.getGradeInActivity();
        if (grade <= 0) {
            grade = PvP5Helper.getRaceGradeByRoleId(roleId);
        }
        if (grade <= 0) {
            List param = MessageMgr.getStringList((Object[])new Object[]{50, StringConstant.ID2String((String)"5v5竞技场", (int)294)});
            MessageMgr.sendMsgNotify((long)roleId, (int)160340, (List)param);
            return false;
        }
        if (Pvp5races.selectIsend((Integer)grade) == null) {
            final int finalGrade = grade;
            new Procedure(){

                protected boolean process() {
                    PvP5Race xpvprace = Pod.newPvP5Race();
                    Pvp5races.insert((Integer)finalGrade, (PvP5Race)xpvprace);
                    return true;
                }
            }.submit();
        }
        if (PvP5RaceProxy.isEnd(grade)) {
            MessageMgr.sendMsgNotify((long)roleId, (int)160348, null);
            return false;
        }
        PvP5CampPolicy.Policy policy = PvP5CampPolicy.create(roleId, grade);
        if (policy == null) {
            return false;
        }
        policy.divide();
        int camp = policy.getCamp();
        int mapId = policy.getMapId();
        PvPResult result = PvP5Helper.checkRoleEnterCondition(roleId, grade, camp, mapId);
        if (result.get() != 0) {
            result.handle();
            return false;
        }
        Role mapRole = RoleManager.getInstance().getRoleByID(roleId);
        if (mapRole == null) {
            return false;
        }
        if (mapId == mapRole.getMapId()) {
            this.onRoleEnterScene(roleId, mapId);
            return true;
        }
        MapConfig mapConf = (MapConfig)ConfigManager.getInstance().getConf(MapConfig.class).get(mapId);
        boolean ret = Transfer.justGotoDeltaWhileCommit((long)roleId, (long)mapId, (int)mapConf.getXjPos(), (int)mapConf.getYjPos(), (int)gotoType, (int)10);
        return ret;
    }

    public void doApplyLeave(long roleId) {
        this.transferOutScene(roleId);
    }

    public boolean onRoleEnterScene(final long roleId, final int mapId) {
        final int grade = PvP5Helper.getRaceGradeByMapId(mapId);
        if (grade <= 0) {
            return false;
        }
        if (!this.isActivityTime()) {
            if (!(Module.existState((long)roleId, (int)507004) || Module.existState((long)roleId, (int)507005) || Module.existState((long)roleId, (int)507027))) {
                this.forceLeave(roleId);
            }
            return true;
        }
        if (Transaction.current() != null) {
            TeamManager.getInstance().delTeamMatchAsyn(roleId);
        } else {
            new Procedure(){

                public boolean process() {
                    TeamManager.getInstance().delTeamMatchAsyn(roleId);
                    return true;
                }
            }.submit();
        }
        Procedure proc = new Procedure(){

            protected boolean process() {
                PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(grade);
                return race.roleEnter(roleId, mapId);
            }
        };
        if (Transaction.current() != null) {
            Procedure.pexecuteWhileCommit((Procedure)proc);
        } else {
            proc.submit();
        }
        return true;
    }

    public boolean onRoleLeaveScene(final long roleId, int mapId, boolean isChangeMap) {
        final int grade = PvP5Helper.getRaceGradeByMapId(mapId);
        if (grade <= 0) {
            return false;
        }
        PvP5RoleStateManager.getInstance().setRolePvPState(roleId, 0);
        Procedure proc = new Procedure(){

            protected boolean process() {
                PvP5RaceProxy race = PvP5RaceProxy.getPvP5RaceProxy(grade);
                return race.roleLeave(roleId);
            }
        };
        if (Transaction.current() != null) {
            if (isChangeMap) {
                proc.call();
            } else {
                Procedure.pexecuteWhileCommit((Procedure)proc);
            }
        } else {
            proc.submit();
        }
        return true;
    }

    public void onRoleOnline(long roleId, int mapId) {
        int grade = PvP5Helper.getRaceGradeByMapId(mapId);
        PvP5CampPolicy.Policy policy = PvP5CampPolicy.create(roleId, grade);
        if (policy == null) {
            return;
        }
        policy.divide();
        if (mapId != policy.getMapId()) {
            mapId = policy.getMapId();
        }
        if (!this.onRoleEnterScene(roleId, mapId)) {
            PvP5Helper.summonByRole(roleId, mapId);
        }
    }

    public void onRoleOffline(long roleId) {
        int mapId = Properties.selectSceneid((Long)roleId).intValue();
        this.onRoleLeaveScene(roleId, mapId, false);
    }

    public boolean doGetAward(final long roleId, final int boxType) {
        new Procedure(){

            protected boolean process() {
                PvP5RoleProxy pvpRoleProxy = PvP5RoleProxy.getPvP5RoleProxy(roleId, false);
                return pvpRoleProxy.openBox(boxType);
            }
        }.submit();
        return true;
    }

    public void onTeamMemberLeave(long roleId) {
        Role mapRole = RoleManager.getInstance().getRoleByID(roleId);
        if (mapRole != null && PvP5Helper.isPvPMap(mapRole.getMapId()) && !PvP5RoleStateManager.getInstance().checkPvPStateCanOperationTeam(roleId)) {
            PvP5RoleStateManager.getInstance().setRolePvPState(roleId, 0);
        }
    }

    static class SingletonHolder {
        static PvP5Control singleton = new PvP5Control();

        SingletonHolder() {
        }
    }
}

